/******************************************************************************/
/*
                                  contacts.h
*/
/******************************************************************************/

#ifndef INCLUDE_CONTACTS_H
#define INCLUDE_CONTACTS_H

/***********/
/* defines */
/***********/

/*******************/
/* data structures */
/*******************/

typedef struct STRUCT_CONTACTS_ENTRY
{
   struct STRUCT_CONTACTS_ENTRY *NextEntry,
                                *PrevEntry;

   int  EntryNumber;

   char  *LDIFcnPtr,                           /* common name */
         *LDIFcPtr,                            /* country */
         *LDIFdescriptionPtr,                  /* description */
         *LDIFdnPtr,                           /* distinguished name */
         *LDIFfacsimileTelephoneNumberPtr,     /* first name */
         *LDIFgivenNamePtr,                    /* last name */
         *LDIFlPtr,                            /* locality (city) */
         *LDIFmailPtr,                         /* email address */
         *LDIFmobilePtr,                       /* mobile telephone */
         *LDIFpagerPtr,                        /* page number */
         *LDIFpostalAddressPtr,                /* street address */
         *LDIFpostalCodePtr,                   /* post/ZIP code */
         *LDIFsnPtr,                           /* family name */
         *LDIFstPtr,                           /* state address */
         *LDIFsoyMAILlistPtr,                  /* soyMAIL address list */
         *LDIFtelephoneNumberPtr;              /* telephone number */

} CONTACTS_ENTRY;

/**************/
/* prototypes */
/**************/

void ContactsAppend (REQUEST_DATA*, char*, char*);
void ContactsCompose (REQUEST_DATA*, int);
void ContactsEdit (REQUEST_DATA*, BOOL);
void ContactsEditButtons (BOOL, BOOL);
BOOL ContactsExport (REQUEST_DATA*);
void ContactsImportLdif (REQUEST_DATA*, char*);
BOOL ContactsLoad (REQUEST_DATA*, char*);
int ContactsLoadFile (REQUEST_DATA*, char*);
void ContactsLoadLdif (REQUEST_DATA*, char*);
char* ContactsLdifParse (char**, char**, char**);
int ContactsLdifRecord (FILE*, char*, char*);
void ContactsMergeLdif (REQUEST_DATA*, char*);
char* ContactsNameAs (char*);
void ContactsPage (REQUEST_DATA*, BOOL);
BOOL ContactsPageRequest (REQUEST_DATA*);
int ContactsPostalAddress (CONTACTS_ENTRY*, char*, int);
void ContactsPrintView (REQUEST_DATA*);
void ContactsSave (REQUEST_DATA*);
void ContactsSort (REQUEST_DATA*);

#endif /* INCLUDE_CONTACTS_H */

/******************************************************************************/

