/*****************************************************************************/
/*
                                 request.h

COPYRIGHT
---------
Copyright (C) 2004 Mark G.Daniel
This program, comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it
under the conditions of the GNU GENERAL PUBLIC LICENSE, version 2.

*/
/*****************************************************************************/

#ifndef INCLUDE_REQUEST_H
#define INCLUDE_REQUEST_H

#include "compose.h"
#include "mime.h"

#define VMSok(x) ((x) & STS$M_SUCCESS)
#define VMSnok(x) !(((x) & STS$M_SUCCESS))

#define BOOL int
#define TRUE 1
#define FALSE 0

/*************/
/* constants */
/*************/

/* just ambit numbers! */
#define PAGE_FOLDER         99199
#define PAGE_SEARCH         99299
#define PAGE_OPTIONS        99399
#define PAGE_CONTACTS       99499
#define PAGE_COMPOSE        99599
#define PAGE_MESSAGE        99699
#define PAGE_HELP           99799

/* magic number to indicate all message from 1..n */ 
#define RANGE_ALL_MSGS     999999999
/* magic number to indicate 'the most recent messages' */
#define RANGE_MOST_RECENT  999999998

/*******************/
/* data structures */
/*******************/

/* forward references */
typedef struct STRUCT_CONTACTS_ENTRY CONTACTS_ENTRY;
                    
/**************/
/* structures */
/**************/

typedef struct STRUCT_USER_OPTIONS
{
   int  CheckNewMailMins,
        CheckNewMailMSIE,
        CheckNewMailNonAjax,
        ComposeHTML,
        FolderButtons,
        FontSize,
        ItemsPerPage,
        MassageRead,
        MessagesPerPage,
        MessageReadHistory,
        OptionsApplied,
        OptionsLoaded,
        ReadPreference,
        UseOnlyMAILFile;

   char  CharSet [24],
         FontFamily [96],
         Language [64],
         PersonalName [128],
         QuoteChar [8],
         SmtpFrom [128],
         Theme [32],
         YouGotMail [32];

} USER_OPTIONS;

/* need 'regex_t' */
#include <regex.h>

typedef struct STRUCT_SEARCH_DATA
{
   BOOL  InProgress,
         SearchProblem,
         SelectNotSearch;

   int  Category,
        DateScope,
        DateDay,
        DateMonth,
        DateYear,
        FirstIdSearched,
        HitCount,
        LastIdSearched,
        ResultsEvery,
        SearchCount,
        SearchSeconds;

   unsigned long BinTimeBefore [2],
                 BinTimeSince [2];

   char  Attachment [31+1],
         Cc [31+1],
         Criteria [127+1],
         From [31+1],
         Message [31+1],
         Subject [31+1],
         To [31+1];

   regex_t  RegexAttachment,
            RegexCc,
            RegexFrom,
            RegexMessage,
            RegexSubject,
            RegexTo;

} SEARCH_DATA;

#define MESSAGE_READ_HISTORY_MAX 30

typedef struct STRUCT_REQUEST_DATA
{
   /* version right up front so it's relative position is constant! */
   char  StateVersion [16];
   /* state data is this same request struct, from any previous request */
   int  StateSaveCount;
   void  *StateDataPtr;

   char  RemoteUser [USERNAME_MAX+1];
   unsigned long  RemoteUserLength;

   int  ThisPageIdent,
        PrevPageIdent;

   char  *CgiPathInfoPtr,
         *CgiQueryStringPtr,
         *CgiRequestMethodPtr,
         *CgiRequestUriPtr,
         *CgiScriptNamePtr,
         *CharSetPtr,
         *FieldFocusPtr;

   char  UserName [USERNAME_MAX+1];
   unsigned long  UserNameLength;
   char  MailFileName [255+1];
   unsigned long  MailFileNameLength;
   char  DestMailFileName [255+1];
   unsigned long  DestMailFileNameLength;
   char  FolderName [FOLDER_NAME_MAX+1];
   unsigned long  FolderNameLength;
   char  DestFolderName [FOLDER_NAME_MAX+1];
   unsigned long  DestFolderNameLength;
   char  AttachmentName [255+1];
   unsigned long  AttachmentNameLength;

   int  FolderMessageCount,
        FolderRefreshSeconds,
        MassageMessage,
        MessageHash,
        MessageId,
        MessageReadPreference,
        NewMessages,
        RangeIdCount,
        RangeIdStart,
        RangeIdVector;

   short  MessageReadHistory [MESSAGE_READ_HISTORY_MAX+1];
   int  MessageReadHistoryCount;

   char  *MsgIdListPtr;
   int  MsgIdListCount;

   BOOL  ClientHasJavaScript,
         HtmlTextIsPresent,
         NewMailNoticed,
         NewMailPlay,
         NewMailValid,
         PlainTextIsPresent,
         PostMaster,
         PrivateAccess,
         PublicAccess,
         PublicNoNewMail,
         PublicWildcard,
         ReadHtmlText,
         ReadPlainText;

   char  FormAction [96],
         PublicAccessString [FOLDER_NAME_MAX+1],
         PublicAccessTitle [FOLDER_NAME_MAX+1];

   USER_OPTIONS  UserOptions;
   COMPOSE_DATA  ComposeData;
   SEARCH_DATA  SearchData;

   char  *ContactsTextPtr;
   int  ContactsTextLength;
   CONTACTS_ENTRY  *ContactsListPtr;
   int  ContactsErrorCount,
        ContactsLoadCount,
        ContactsUnknownCount;

} REQUEST_DATA;

/**************/
/* prototpyes */
/**************/

void RequestLastLogin (REQUEST_DATA*);
void RequestParseDestFileFolder (REQUEST_DATA*, char*);
void RequestParseFileFolder (REQUEST_DATA*, char*);
int RequestParsePath (REQUEST_DATA*);
int RequestPrivate (REQUEST_DATA*);
BOOL RequestPrivateDefaults (REQUEST_DATA*);
void RequestPrivateStateSave (REQUEST_DATA*);
int RequestPublic (REQUEST_DATA*);
BOOL RequestPublicDefaults (REQUEST_DATA*);
void RequestPublicStateSave (REQUEST_DATA*);
void RequestVmsMailContext (REQUEST_DATA*);
BOOL RequestStateRestore (REQUEST_DATA*);

#endif /* INCLUDE_REQUEST_H */

/*****************************************************************************/
