/*****************************************************************************/
/*
                                  soyMAIL.c

                         ~ Son Of YahMAIL (ta da!) ~


COPYRIGHT
---------
Copyright (C) 2005,2006 Mark G.Daniel
This program, comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it
under the conditions of the GNU GENERAL PUBLIC LICENSE, version 2.


VERSION HISTORY
---------------
18-APR-2006  MGD  v1.1.0,
                  add configuration directive [private-request] and modify
                    behaviour to determine private or public access
                  add configuration directive [update-last-login] with
                    RequestLastLogin() optionally sets private access
                    SYSUAF last-login at first (initial GET) access 
                  bugfix; ComposeSelfAddress() size for calloc()
                  bugfix; RequestPublic() parsing folder with GET
09-APR-2006  MGD  v1.0.0,
                  add [send-close] and ComposeSendClose()
                  significant rework to rationalise public and private
                  remove default MAIL and NEWMAIL folders in listings
                  MessagePage() and PublicMessagePage() precede each
                    message part/attachment with an anchor/link to allow
                    for right-click browser save-as 
                  LangLoad() in conjunction with LANGDEF.H used to provide
                    details on missing/extra entries in a language file
                  ConfigPublicAccess() support wildcard folder mapping
                    in conjunction with extensive changes to PUBLIC.C
                  bugfix; OptionsSoyMail() propagation of personal
                    you-got-mail when when changing language option
                  bugfix; CerealDataOut() allow ambit 3x buffer space
27-MAR-2006  MGD  v0.4.3,
                  [wrap-text-at] transmogrified to [massage-read]
                    option now wraps long lines, eliminates extra line breaks
                    and removes any PGP signature
                  MessagePgpSigned() and MessagePgpCut() for PGP signature
                  small accomodation for Purveyor around 'binary' fwrite()s
                  RequestPrivate() Purveyor (1.2 at least) requires a full
                    URL to redirect (during logout)
                  refine 'watch' detail including MTA SMTP identification
                  'checking for new mail' uses beginWorking() progress dots
19-MAR-2006  MGD  v0.4.2,
                  AttachFile() ensure any file system path is stripped
                    from the attachment name before saving (MSIE)
                  refine HtmlNumericDeEntify() and HtmlCharacterDeEntify()
                  LangSame() modify comparison so that the message can
                    contain HTML entities useful in some buttons (e.g. &#10;)
                  AddressListMassage() refine address reduction (yep - again!)
                    also allow for appending a default host/domain if the
                    configuration directive [SMTP-defaulthost] is set
                  configuration directive [logout-realm] added to allow logout
                     for Apache (must be set the same as 'AuthName')
                  MimeDec8bit() disable reporting and always return OK
                  refine contact management wrt duplicate common names
                  bugfix; InetMailParseHeader() non-MIME MIME-like headers
                  bugfix; ContactsSave() to empty LDIF file
                  bugfix; MessageBodyIdentify() when generating plain from
                    HTML-only content call MimeDecProcessPart() to decode
                  bugfix; MessageBodyIdentify() default a non-MIME message
                    message to 8-bit, plain-text
13-MAR-2006  MGD  v0.4.1,
                  HtmlSanitise() suppress "background-image"
                  bugfix; ComposeSelfAddress() 'len' initialization
12-MAR-2006  MGD  v0.4.0,
                  MimeDecParseBody() return FALSE on detectable parse error
                    while all callers of this function check return and 
                    process on success or failure of the parse
                  MimeDecParseError() to report MIME parse problems
                  move input focus to the field most appropriate to the stage
                    of message composition, defaulting to the message text
                  remove 'noisy' message count from [message] range button
                  RequestPrivate() no longer include the username when
                    generating the form action URI unless POSTMASTER
                    facility in use (this reduces the leakage of potentially
                    sensitive information through the "Referer:.." header)
                  bugfix; RequestPrivate() do not upper-case username when
                    parsing path as it can interfere with VMS external auth
                  bugfix; ComposeSelfAddress() with rationalization of 'self' 
                    address generation and using this for the "From:" header
                  bugfix; allow MIME related headers (e.g. "Content-type:")
                    to precede the "MIME-version:" header (but cancel MIME
                    if it is not ultimately found in the message header)
04-MAR-2006  MGD  v0.3.9,
                  MessagePage() add MessageButtons() after longer messages
                  bugfix; CgiLibEnvironmentInit() for VMS Apache V2.n
                    and later (as with Apache V1.n) freopen("mrs=16384")
27-FEB-2006  MGD  v0.3.8,
                  ComposePageRequest() support VMS copy-send/forward/reply
                  CallMailGoToNewMail() if the new message count differs
                    from the messages selected count then adjust it
                  ComposeSendMessage() expand MX_.. logical names that
                    can be used to generate the "From:" address
                  ComposePage() [signature] button only if the user has a
                    signature file specified
                  RequestPrivate() refine [logout] mechanism to improve
                    overall behaviour and avoid hole if MSIE [cancel]s
                  [logout] now has associated JavaScript confirm explaining 
                    the logout basics and allowing an opportunity to cancel
                  [close] now has a JavaScript confirm for compose page
                  configuration directive [greeting] added to allow an
                    initial site-specific message shown in the status panel
                  OptionsWithinReason() make default OPTIONS_READ_PLAIN1_HTML2
                  refine MessageBodyIdentify() to manufacture plain-text
                    content when there is only HTML content
                  bugfix; MainMenuRequest() FOLDER_LIST_CHANGE detect 't'
                  bugfix; CallMailMessageDelete() close mail file to
                    empty WASTEBASKET before continuing request
                  bugfix; CallMailMessageCopyMove() adjust new message
                    count regardless of whether it's a copy or a move
16-FEB-2006  MGD  v0.3.7,
                  when used from the message page the main menu [compose]
                    button should provide a blank message, when used from the
                    compose page it should propagate any in-composition message
                  main menu [close] button for child windows
                  AddressListMassage() refine "<address>, <address>" reduction
                  provide more informative message if CallMailGetUserProfile()
                    reports MAIL$_NOSUCHUSER because of no profile entry
                  bugfix; MimeDecProcessPart() sanity check on pointer
                    not length (after all you can have empty content)
                  bugfix; ContactsEdit() no sanity check on un-specified
                    contact, just memset() zero it and continue as 'new' entry
12-FEB-2006  MGD  v0.3.6
                  optional folder buttons on left-side of message listing
                  support saving message as "message/rfc822" 'attachment'
                  refine MimeDecParseBody() to accomodate "message/rfc822"
                    attachments and any such internal MIME parts
                  modified [reply-to] option to [smtp-from] and in conjunction
                    with [personal-name] have ComposePageRequest() generate a
                    "From:" header more in line with TCPIP$SMTP_FROM behaviour
                  add explicit [reply-to] button and field so that messages
                    can individually have a reply-to set against them
                  ComposeMime() add client traceability information to
                    "Received:" header field
                  bugfix; default charset should be ISO-8859-1 not IS0-8859-1
                  bugfix; AttachComposeList() attachment size calculation
                  bugfix; RequestParsePath() attachment names can contain '/'
                  bugfix; SearchKeyword() lower-case the keyword!
26-JAN-2006  MGD  v0.3.5
                  initial public BETA release
01-FEB-2005  MGD  development commences
*/
/*****************************************************************************/

#define COPYRIGHT_DATE "2005,2006"
#define SOFTWAREVN "1.1.0"
#define SOFTWARENM "SOYMAIL"
#ifdef __ALPHA
#  define SOFTWAREID SOFTWARENM " AXP-" SOFTWAREVN
#endif
#ifdef __ia64
#  define SOFTWAREID SOFTWARENM " IA64-" SOFTWAREVN
#endif
#ifdef __VAX
#  define SOFTWAREID SOFTWARENM " VAX-" SOFTWAREVN
#endif

#ifdef SOYMAIL_VMS_V6
#undef _VMS_V6_SOURCE
#define _VMS_V6_SOURCE
#undef __VMS_VER
#define __VMS_VER 60000000
#undef __CRTL_VER
#define __CRTL_VER 60000000
#endif

#ifndef __VAX
#   pragma nomember_alignment
#endif

/* standard C header files */
#include <ctype.h>
#include <errno.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* VMS related header files */
#include <descrip.h>
#include <lib$routines.h>
#include <prvdef.h>
#include <ssdef.h>
#include <stsdef.h>

/* application specific */
#include "soymail.h"
#include "callmail.h"
#include "cgilib.h"
#include "config.h"
#include "mainmenu.h"
#include "mta.h"
#include "other.h"
#include "request.h"
#include "message.h"

#define FI_LI __FILE__, __LINE__

/******************/
/* global storage */
/******************/

BOOL  Debug,
      IsCgiPlus,
      WatchEnabled;

int  VmsVersion;

unsigned long  CurrentVmsBinTime [2];
unsigned short  CurrentVmsNumTime [7];

char  *CgiEnvironmentPtr,
      *CgiRequestUriPtr,
      *SoyMailStatusPtr,
      *SoyMailScriptPath = "/soymail/-/";

char  CopyrightDate [] = COPYRIGHT_DATE,
      SoftwareId [] = SOFTWAREID,
      SoftwareVn [] = SOFTWAREVN,
      Utility [] = "SOYMAIL";

char  CommandLine [256],
      CurrentVmsTimeString [48],
      LocalHostName [128],
      SoftwareEnv [96];

USER_OPTIONS  UserOptions;
REQUEST_DATA  RequestData;
VMS_MAIL_USER  VmsMailUser;

/********************/  
/* external storage */
/********************/  

extern  CONFIG_DATA SoyMailConfig;

/**************/
/* prototypes */
/**************/

int sys$gettim (__unknown_params);
int sys$numtim (__unknown_params);

/*****************************************************************************/
/*
*/

main (int argc, char* argv[])
       
{
   int  status;
   VMS_MAIL_MSG  MailMsg;
   VMS_MAIL_USER  UserData;

   /*********/
   /* begin */
   /*********/

   StatTimer (FALSE);

   sprintf (SoftwareEnv, "%s, %s, %s",
            SOFTWAREID, (char*)CgiLibEnvironmentVersion(), BUILD_DATETIME);

   if (getenv ("SOYMAIL$DBUG"))
   {
      /* some contortions to accomodate OSU */
      Debug = TRUE;
      if (!getenv ("WWWEXEC_RUNDOWN_STRING"))
      {
         fprintf (stdout,
"Content-Type: text/plain\nScript-Control: X-content-encoding-gzip=0\n\n");
         CgiLibEnvironmentSetDebug (1);
      }
   }

   CgiLibEnvironmentInit (argc, argv, TRUE);
   if (Debug) CgiLibEnvironmentRecordOut ();

   if (Debug)
   {
      /* continuing contortions */
      if (getenv ("WWWEXEC_RUNDOWN_STRING"))
      {
         fprintf (stdout, "Content-Type: text/plain\n\n");
         CgiLibEnvironmentSetDebug (0);
      }
   }

   GetParameters (argc, argv);

   CgiLibResponseSetSoftwareID (SoftwareId);
   CgiLibResponseSetErrorStatus (403);
   CgiLibResponseSetErrorMessage ("reported by soyMAIL");

   CgiEnvironmentPtr = CgiLibEnvironmentName ();
   VmsVersion = GetVmsVersion ();

   ProcessRequest ();
}

/****************************************************************************/
/*
*/ 

ProcessRequest ()

{
   int gethostname (char*, int);

   int  PostBufferCount;
   char  *cptr, *sptr, *zptr,
         *PostBufferPtr;
   REQUEST_DATA  *rdptr;

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "ProcessRequest()\n");

   if (cptr = TrnLnm ("SOYMAIL$WATCH", NULL, 0))
   {
      if (Debug) fprintf (stdout, "SOYMAIL$WATCH |%s|\n", cptr);
      WatchEnabled = TRUE;
      if (isdigit(*cptr))
      {
         /* if it doesn't match the remote address then disable again */
         if (!(sptr = CgiVar ("REMOTE_ADDR"))) sptr = "";
         if (strcmp (cptr, sptr)) WatchEnabled = 0;
      }
   }

   if (Debug) WatchEnabled = TRUE;

   if (WatchEnabled)
   {
      /* initialize watch mode */
      WatchThis (NULL);
      WatchThis ("SYSTEM !AZ", GetPlatformDescription());
      cptr = CgiLibVarNull ("SERVER_SOFTWARE");
      if (!cptr) cptr = "?";
      WatchThis ("SERVER !AZ", cptr);
      WatchThis ("!AZ", SoftwareId);
      cptr = CgiLibVarNull ("HTTP_USER_AGENT");
      if (!cptr) cptr = "?";
      WatchThis ("AGENT !AZ", cptr);
   }

   sys$gettim (&CurrentVmsBinTime);
   sys$numtim (&CurrentVmsNumTime, &CurrentVmsBinTime);
   PrintFao (CurrentVmsTimeString, sizeof(CurrentVmsTimeString),
             "!20%D", &CurrentVmsBinTime);

   rdptr = &RequestData;

   /* some of these will be used during configuration so get 'em now */
   CGIVAR (rdptr->CgiRequestMethodPtr, "REQUEST_METHOD");
   CGIVAR (rdptr->CgiRequestUriPtr, "REQUEST_URI");
   CGIVAR (rdptr->CgiScriptNamePtr, "SCRIPT_NAME");
   CGIVAR (rdptr->CgiPathInfoPtr, "PATH_INFO");
   CGIVAR (rdptr->CgiQueryStringPtr, "QUERY_STRING");

   /* load the soyMAIL configuration */
   ConfigLoad (rdptr);

   if (SoyMailConfig.DowntimeMessage)
   {
      CgiLibResponseHeader (503, "text/html");
      fprintf (stdout, "%s &nbsp;&nbsp;&mdash;&nbsp;&nbsp %s\n",
               InetMailRfcVmsDate(CurrentVmsTimeString),
               SoyMailConfig.DowntimeMessage);
      return;
   }

   /* SMTP server identification (must be done after the configuration load) */
   if (WatchEnabled) MtaSmtpServerPoll (SoyMailConfig.SmtpServerHost);

   if (rdptr->CgiQueryStringPtr[0])
   {
      cptr = rdptr->CgiQueryStringPtr;
      if (!strcmp (cptr, "help") || !strncmp (cptr, "help+", 5))
      {
         /* public access to the consolidated help page */
         OptionsPublicGet (rdptr);

         cptr += 4;
         if (*cptr == '+')
         {
            cptr++;
            zptr = (sptr = rdptr->UserOptions.Language) +
                   sizeof(rdptr->UserOptions.Language)-1;
            while (*cptr && sptr < zptr) *sptr++ = *cptr++;
            *sptr = '\0';
         }

         LangLoad (rdptr->UserOptions.Language);
         if (!rdptr->UserOptions.CharSet[0])
            strcpy (rdptr->UserOptions.CharSet, LangFor("lang_charset"));

         HelpAll (rdptr);
         return; 
      }
   }

   CGIVAR (cptr, "REMOTE_USER");
   rdptr->UserNameLength = strzcpy (rdptr->UserName, cptr,
                                    sizeof(rdptr->UserName));
   rdptr->RemoteUserLength = strzcpy (rdptr->RemoteUser, cptr,
                                      sizeof(rdptr->RemoteUser));

   if (!strcmp (rdptr->CgiRequestMethodPtr, "POST"))
   {
      /* read and create the CGI variable equivalents of the body fields */
      CgiLibReadRequestBody (&PostBufferPtr, &PostBufferCount);
      if (WatchEnabled) WatchThis ("POST !UL bytes", PostBufferCount);
      if (!PostBufferPtr || !PostBufferCount)
      {
         ErrorExit (SS$_BUGCHECK, FI_LI);
         return;
      }
      if (WatchEnabled)
         WatchThis ("BODY !UL bytes\n!AZ", PostBufferCount, PostBufferPtr);
      CgiLibFormRequestBody (PostBufferPtr, PostBufferCount);
      free (PostBufferPtr);
      if (WatchEnabled)
         while ((cptr = CgiLibVarNull ("*")) != NULL)
            WatchThis ("!AZ", cptr);
      /* now we can start to use the FORM_.. variables */
   }

   CGIVARNULL (cptr, "FORM_JAVASCRIPT");
   if (cptr) rdptr->ClientHasJavaScript = TRUE;

   if (gethostname (LocalHostName, sizeof(LocalHostName)) != 0)
      strcpy (LocalHostName, "unknown");

   if (rdptr->PrivateAccess)
      RequestPrivate (rdptr);
   else
   if (rdptr->PublicAccess)
      RequestPublic (rdptr);
   else
      ErrorExit (SS$_BUGCHECK, FI_LI);

   /* reset watch mode as necessary */
   if (WatchEnabled) WatchThis (NULL);
}

/*****************************************************************************/
/*
Get "command-line" parameters, whether from the command-line or from a
configuration symbol or logical containing the equivalent.
*/

GetParameters
(
int argc,
char *argv[]
)
{
   static unsigned long  Flags = 0;

   int  status,
        SkipParameters;
   unsigned short  Length;
   char  ch;
   char  *aptr, *cptr, *clptr, *sptr;
   $DESCRIPTOR (CommandLineDsc, CommandLine);

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "GetParameters()\n");

   if ((clptr = getenv ("SOYMAIL$PARAM")) == NULL)
   {
      /* get the entire command line following the verb */
      status = lib$get_foreign (&CommandLineDsc, 0, &Length, &Flags);
      if (VMSnok (status)) exit (status);
      (clptr = CommandLine)[Length] = '\0';
   }

   /* the first is CSWS 1.2/1.3, the other two for SWS 2.0 */
   if (getenv ("APACHE$SHARED_SOCKET") != NULL ||
       getenv ("APACHE$PARENT_PID") != NULL ||
       getenv ("APACHE$SERVER_TAG") != NULL)
      SkipParameters = 99;
   else
   /* if OSU environment then skip P1, P2, P3 */
   if (getenv ("WWWEXEC_RUNDOWN_STRING") != NULL)
      SkipParameters = 3;
   else
      SkipParameters = 0;

   aptr = NULL;
   ch = *clptr;
   for (;;)
   {
      if (aptr != NULL && *aptr == '/') *aptr = '\0';
      if (!ch) break;

      *clptr = ch;
      if (Debug) fprintf (stdout, "clptr |%s|\n", clptr);
      while (*clptr && isspace(*clptr)) *clptr++ = '\0';
      aptr = clptr;
      if (*clptr == '/') clptr++;
      while (*clptr && !isspace (*clptr) && *clptr != '/')
      {
         if (*clptr != '\"')
         {
            clptr++;
            continue;
         }
         cptr = clptr;
         clptr++;
         while (*clptr)
         {
            if (*clptr == '\"')
               if (*(clptr+1) == '\"')
                  clptr++;
               else
                  break;
            *cptr++ = *clptr++;
         }
         *cptr = '\0';
         if (*clptr) clptr++;
      }
      ch = *clptr;
      if (*clptr) *clptr = '\0';
      if (Debug) fprintf (stdout, "aptr |%s|\n", aptr);
      if (!*aptr) continue;

      if (SkipParameters)
      {
         /*
             Apache supplies query string keywords on the command line
             to a CGI script.  With Apache the command-line is ignored
             up until the /_APACHE qualifier triggers anything following
             to be processed.             
         */
         if (!strsame (aptr, "/_APACHE", -1))
         {
            SkipParameters--;
            continue;
         }
         SkipParameters = 0;
      }

      /***********/
      /* process */
      /***********/

      if (strsame (aptr, "/DBUG", -1))
      {
         Debug = TRUE;
         continue;
      }

      if (strsame (aptr, "/REGEX", -1))
      {
         /* kludgy, kludgy, kludgy! */
         SearchRegexCheck (clptr+1);
         exit (SS$_NORMAL);
      }

      if (*aptr == '/')
      {
         fprintf (stdout, "%%%s-E-IVQUAL, unrecognized qualifier\n \\%s\\\n",
                  Utility, aptr+1);
         exit (STS$K_ERROR | STS$M_INHIB_MSG);
      }

      fprintf (stdout, "%%%s-E-MAXPARM, too many parameters\n \\%s\\\n",
               Utility, aptr);
      exit (STS$K_ERROR | STS$M_INHIB_MSG);
   }
}

/*****************************************************************************/

